-module(doudizhu_ai_sup).
-behaviour(supervisor).

-export([start_link/0]).
-export([init/1]).

start_link() ->
    supervisor:start_link({local, ?MODULE}, ?MODULE, []).

init([]) ->
    SupFlags = #{
        strategy => one_for_one,
        intensity => 10,
        period => 60
    },

    Children = [
        #{
            id => ml_engine,
            start => {ml_engine, start_link, []},
            restart => permanent,
            shutdown => 5000,
            type => worker,
            modules => [ml_engine]
        },
        #{
            id => training_system,
            start => {training_system, start_link, []},
            restart => permanent, 
            shutdown => 5000,
            type => worker,
            modules => [training_system]
        },
        #{
            id => visualization,
            start => {visualization, start_link, []},
            restart => permanent,
            shutdown => 5000, 
            type => worker,
            modules => [visualization]
        }
    ],

    {ok, {SupFlags, Children}}.